#include "StdAfx.h"
#include ".\bmsheader.hpp"

namespace Lmt {
namespace Max2Bms {
	BmsHeader::BmsHeader( void ) {
		this->Clear();
	}

	BmsHeader::~BmsHeader( void ) {
	}

	BmsPlayStyles BmsHeader::GetPlayStyle( void ) const {
		return m_style;
	}

	void BmsHeader::SetPlayStyle( BmsPlayStyles style ) {
		m_style = style;
	}

	wstring BmsHeader::GetGenre( void ) const {
		return m_genre;
	}

	void BmsHeader::SetGenre( const wstring &genre ) {
		m_genre = genre;
	}

	wstring BmsHeader::GetTitle( void ) const {
		return m_title;
	}

	void BmsHeader::SetTitle( const wstring &title ) {
		m_title = title;
	}

	wstring BmsHeader::GetArtist( void ) const {
		return m_artist;
	}

	void BmsHeader::SetArtist( const wstring &artist ) {
		m_artist = artist;
	}

	int BmsHeader::GetInitialTempo( void ) const {
		return m_initialTempo;
	}

	void BmsHeader::SetInitialTempo( int tempo ) {
		m_initialTempo = tempo;
	}

	int BmsHeader::GetDifficulty( void ) const {
		return m_difficulty;
	}

	void BmsHeader::SetDifficulty( int difficulty ) {
		m_difficulty = difficulty;
	}

	BmsJudgeRanks BmsHeader::GetJudgeRank( void ) const {
		return m_rank;
	}

	void BmsHeader::SetJudgeRanks( BmsJudgeRanks rank ) {
		m_rank = rank;
	}

	int BmsHeader::GetTotalGroove( void ) const {
		return m_totalGroove;
	}

	void BmsHeader::SetTotalGroove( int total ) {
		m_totalGroove = total;
	}

	wstring BmsHeader::GetTitleImagePath( void ) const {
		return m_imagePath;
	}

	void BmsHeader::SetTitleImagePath( const wstring &imagePath ) {
		m_imagePath = imagePath;
	}

	void BmsHeader::Clear( void ) {
		m_style = SinglePlayStyle;
		m_genre = L"";
		m_title = L"";
		m_artist = L"";
		m_initialTempo = 120;
		m_difficulty = 1;
		m_rank = NormalJudgeRank;
		m_totalGroove = 100;
		m_imagePath = L"";
	}
}
}
