#pragma once

#include "BmsPlayStyles.hpp"
#include "BmsJudgeRanks.hpp"

namespace Lmt {
namespace Max2Bms {
	class BmsHeader {
	public:
		BmsHeader( void );
		~BmsHeader( void );
		BmsPlayStyles GetPlayStyle( void ) const;
		void SetPlayStyle( BmsPlayStyles style );
		wstring GetGenre( void ) const;
		void SetGenre( const wstring &genre );
		wstring GetTitle( void ) const;
		void SetTitle( const wstring &title );
		wstring GetArtist( void ) const;
		void SetArtist( const wstring &artist );
		int GetInitialTempo( void ) const;
		void SetInitialTempo( int tempo );
		int GetDifficulty( void ) const;
		void SetDifficulty( int difficulty );
		BmsJudgeRanks GetJudgeRank( void ) const;
		void SetJudgeRanks( BmsJudgeRanks rank );
		int GetTotalGroove( void ) const;
		void SetTotalGroove( int total );
		wstring GetTitleImagePath( void ) const;
		void SetTitleImagePath( const wstring &imagePath );
		void Clear( void );
	private:
		BmsPlayStyles m_style;
		wstring m_genre;
		wstring m_title;
		wstring m_artist;
		int m_initialTempo;
		int m_difficulty;
		BmsJudgeRanks m_rank;
		int m_totalGroove;
		wstring m_imagePath;
	};
}
}
