#pragma once

#include "AlphaDecimal.hpp"
#include "BmsChannels.hpp"
#include "BmsMeasure.hpp"

namespace Lmt {
namespace Max2Bms {
	class BmsSequence {
	public:
		BmsSequence( void );
		~BmsSequence( void );
		int GetLastMeasureNo( void ) const;
		void SetBackgroundIndex( int index );
		const BmsMeasure * GetMeasure( BmsChannels ch, int measureIndex ) const;
		void Clear( void );
		void Add( BmsChannels ch, int position, AlphaDecimal value );
	private:
		int ChannelToIndex( BmsChannels ch ) const;
		void PositionToMeasure( int position, int *pmeasure, int *pindex ) const;
	private:
		static const int BackgroundOffset = 16;
	public:
		static const int MaxBackgroundCount = 64;
	private:
		typedef map<int, BmsMeasure>  BmsMeasureMap;
		typedef vector<BmsMeasureMap>  BmsMeasureMapArray;
	private:
		enum ChannelMappings {
			PlayableKey1 = 0,
			PlayableKey2 = 1,
			PlayableKey3 = 2,
			PlayableKey4 = 3,
			PlayableKey5 = 4,
			PlayableKey6 = 5,
			PlayableKey7 = 6,
			LongNote1 = 7,
			LongNote2 = 8,
			LongNote3 = 9,
			LongNote4 = 10,
			LongNote5 = 11,
			LongNote6 = 12,
			LongNote7 = 13,
			ChangeTempo = 14,
		};
	private:
		BmsMeasureMapArray m_measures;
		int m_lastMeasureNo;
		int m_bkIndex;
	};
}
}
