#pragma once

#include "PatternFile.hpp"
#include "SongDatabase.hpp"
#include "BmsHeader.hpp"
#include "BmsMaterial.hpp"
#include "BmsSequence.hpp"
#include "BmsGenerator.hpp"

using namespace Lmt;
using namespace Lmt::Max2Bms;

namespace Lmt {
namespace Pt2Bms {
	class Main {
	private:
		struct Options {
			wstring inputPath;
		};
	public:
		static int EntryPoint( int argc, char *argv[] );
		static bool ParseOptions( int argc, char *argv[], Options &opts );
		static void Usage( void );
		static wstring PtLoadResultString( PtLoadResult result );
		static bool SetupHeader( PatternFile *ppt, SongDatabase *psdb, BmsHeader *pheader );
		static bool SetupMaterial( PatternFile *ppt, BmsMaterial *pmaterial );
		static bool SetupSequence( PatternFile *ppt, int keyCount, BmsSequence *psequence );
		static void GenerateBms( BmsGenerator *pgenerator );
	};
}
}
